#!/usr/local/bin/perl
require "pwd.pl";
require "ctime.pl";
##################
#  Build a valid GEMACS input file based on users inputs

$InputDir = "/usr/local/archives/restricted/html/erst/cgi-bin/input";

&PrintHeader;
&ReadEntry;
&PrintResults;



#############
#SUBROUTINES
#############

# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
  print "\n";
}


sub PrintResults{
    &chdir($InputDir);
    $Len = length($Input{'filename'});
    substr($Input{'filename'}, $Len , 1) = ".gem";
    $Filename = $Input{'filename'};
    #print "$Filename<br>\n";
    opendir(INPUTDIR, $InputDir)  || print "Can't open $InputDir: $!<br>\n";
    open(INPUTFILE, ">$Filename") || print "Can't open $Filename: $!<br>\n";
    print INPUTFILE "\$ This File generated by simu.cgi located at\n\$ http://www.npac.syr.edu/restricted/erst\n";
    print INPUTFILE "\$\n\$\n\$\n\$\n";
    print INPUTFILE "\$\tFile: $Filename\n";
    $Date=&ctime(time);
    print INPUTFILE "\$\tDate: $Date";
    print INPUTFILE "\$\n";
    print INPUTFILE "\$\t$Input{'comments'}\n";
    print INPUTFILE "TITLE \"$Input{'title'}\"\n";
    print INPUTFILE "FRQ=$Input{'frq'}\n";
    print INPUTFILE "NUMFIL=$Input{'numfiles'}\n";
    if ($Input{'Debug-module'} eq ""){
	print INPUTFILE "DEBUG=$Input{'debug'}\n";
    }			       
    else{
	print INPUTFILE "DEBUG=$Input{'debug'}, MODULE = $Input{'Debug-module'}\n";
    }
    &PrintInteractions;
    if ($Input{'Other'} ne ""){ 
	print INPUTFILE "$Input{'Other'}\n";
    }
    print INPUTFILE "GMDATA=$Input{'gmdata'}\n";
    print INPUTFILE "\$\n\$\n";
    print INPUTFILE "\$ ESRC Commands\n";
    print INPUTFILE "\$\n";
    print INPUTFILE "$Input{'src'}\n";
    print INPUTFILE "\$\n";
    print INPUTFILE "\$-------GEOMETRY-----\n";
    print INPUTFILE "\$\n";
    print INPUTFILE "$Input{'Geometry'}\n";    

}

sub PrintInteractions{
    print INPUTFILE "SETINT";

    if ($Input{'setGTD'} eq "on"){
	print INPUTFILE "GTD";	
    }
    elsif ($Input{'run'} eq "GTD"){
	&PrintGTD;
    }
    elsif ($Input{'setMOM'} eq "on"){
	print INPUTFILE "MOM";
    }
    elsif ($Input{'setFD'} eq "on"){
	print INPUTFILE "FD";
    }

    print INPUTFILE "\n";
}

sub PrintGTD{
    if ($Input{'setPL'} eq "on"){
	print INPUTFILE " PL";
    }
    elsif ($Input{'setPLREF'} eq "on"){
	print INPUTFILE " PLREF";
    }
    elsif ($Input{'setPLDIF'} eq "on"){
	print INPUTFILE " PLDIF";
    }
    elsif ($Input{'setPLMAT'} eq "on"){
	print INPUTFILE " PLMAT";
    }
    if ($Input{'setCY'} eq "on"){
	print INPUTFILE " CY";
    }
    elsif ($Input{'setCYREF'} eq "on"){
	print INPUTFILE " CYREF";
    }
    elsif ($Input{'setCYDIF'} eq "on"){
	print INPUTFILE " CYDIF";
    }
    elsif ($Input{'setCYMAT'} eq "on"){
	print INPUTFILE " CYMAT";
    }
    if ($Input{'setSW'} eq "on"){
	print INPUTFILE " SW";
    }
    elsif ($Input{'setSWREF'} eq "on"){
	print INPUTFILE " SWREF";
    }
    elsif ($Input{'setSWATT'} eq "on"){
	print INPUTFILE " SWATT";
    }
    elsif ($Input{'setSWDET'} eq "on"){
	print INPUTFILE " SWDET";
    }
    elsif ($Input{'setSWTRW'} eq "on"){
	print INPUTFILE " SWTRW";
    }
    if ($Input{'setEI'} eq "on"){
	print INPUTFILE " EI";
    }
    if ($Input{'setEU'} eq "on"){
	print INPUTFILE " EU";
    }
    if ($Input{'setES'} eq "on"){
	print INPUTFILE " ES";
    }

}
			       
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form
   #$keyword = $in{'keyword'};
   return 1;
}

# reads the arguments passed from the form
sub ReadParse {
    if ($ENV{'REQUEST_METHOD'} eq "GET") { # Read in text
	$in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $in, $ENV{'CONTENT_LENGTH'});
    }

 
    @in = split(/&/, $in);     
    foreach (@in){
	print "$_<br>";
	tr/+/ /;
	s/%(..)/pack("c", hex($1))/ge;
#	s/\n/\n\$/g;
	@temp = split(/=/, $_);
	if ($temp[0] eq "comments"){
	    $temp[1]=~s/\n/\n\$\t/g;
	    $Input{$temp[0]} = $temp[1]; 
	    print "$temp[0]:<br>$Input{$temp[0]}<br>\n";

	}
	if (($temp[0] eq "src") || ($temp[0] eq "Geometry") || ($temp[0] eq "Other")) {
	    $temp[1] =~ s/\n\$//e;
	    $Input{$temp[0]} = $temp[1]; 
	    print "$temp[0]:<br>$Input{$temp[0]}<br>\n";
	}     
	else{
	    $Input{$temp[0]} = $temp[1]; 
	    print "$temp[0]:<br>$Input{$temp[0]}<br>\n";
	}
	undef @temp;
    }
    return 1; 
}





